%%
%postup na zjisteni poctu iteraci L pro pevne zvolenou absolutni chybu mezi
%presnym resenim a aproximaci  pro priklad 4 (linearni proces zrodu a
%zaniku, migrace
% author: Patrik Drda
%%
clear
close all
clc
%% pocatecni hodnoty
eps=10^-7; % abs chyba
max_iter=300; % maximalni pocet iteraci
 
%% volba hodnot r,m,n,t
r=0;  % velikost populace v case t
m=5; % pocatecni velikost populace v case t=0
n=10; % n-ty aproximant , pri kombinaci r=0, m=0, n=0 dojde k zacykleni
t=20; % volba t


%% zadane hodnoty intenzit
 tau=0.1;
mu=0.1;
lambda=0.3;
lambda_0=tau; % podminka: lambda_0 musi byt vetsi nez 0
 
roots_search=2; % volba metody na vypocet korenu; 1 - pomoci matice a vl. cisel; 2- QD - algoritmus
%% tvorba posloupnosti pro lambda(r)
lambda_r=zeros(1,n+m+r);
for i=1:n+m+r
    lambda_r(i)=lambda*i+tau;
end

%% tvorba posloupnosti pro mu(r)
mu_r=zeros(1,n+m+r);
for i=1:n+m+r
   mu_r(i)=mu*i;
end
%%
%% presne reseni  pro pocatecni podm. p_m(0)=1 a volbu r=0 v case t, kdyz uvazujme t celociselne
p_r_presne(t)=(((lambda-mu)/(lambda*exp((lambda-mu)*t)-mu))^(tau/lambda))*(mu*((exp((lambda-mu)*t)-1)/(lambda*exp((lambda-mu)*t)-mu)))^m;

%% 
[h,p_r]=christ_num(r,m,n,lambda_0,lambda_r,mu_r,roots_search,1);% zavola funkci a vypocte cisla h a priblizny vypocet ppsti funkce p_r(t)
k=1;
 while  abs((p_r(t)-p_r_presne(t))')>eps && k<max_iter % pokracuj dokud neni stanovena chyba nebo do max. iterace 
     
 k=k+1;
 L=k;
 [h,p_r]=christ_num(r,m,n,lambda_0,lambda_r,mu_r,roots_search,L); % zavola funkci a vypocte cisla h a priblizny vypocet ppsti funkce p_r(t)

%%
 end
 fprintf('Absolutni chyba=%1.9f, pocatecni iteraci L=%1.0f\n',eps,k)

