% postup pro priblizny vypocet absolutnich pravdepodobnosti, tj p_r(t)=P(X_t=r)
% priklad 2
% author: Patrik Drda
%%
clear
close all
clc
%% for cyklus pro  vykresleni ruznych variant reseni 
%for m=1:4 %zmena tvaru funkce na zmene hodnoty m
for r=0:5 %zmena tvaru funkce na zmene hodnoty r

%% pocatecni hodnoty
%r=1;  % velikost populace v case t
m=1; % pocatecni velikost populace v case t=0
n=10; % n-ty aproximant , pri kombinaci r=0, m=0, n=0 dojde k zacykleni
L=200; % pocet iteraci pro QD algoritmus
t=0.1:0.2:50; % volba t

%% zadan hodnoty intenzit
mu=0.1;
lambda=0.3;
lambda_0=lambda; % podminka: lambda_0 musi byt vetsi nez 0
 
roots_search=1; % volba metody na vypocet korenu; 1 - pomoci matice a vl. cisel; 2- QD - algoritmus
%% tvorba posloupnosti pro lambda(r)
lambda_r=zeros(1,n+m+r);
for i=1:n+m+r
    
    lambda_r(i)=lambda;
end

%% tvorba posloupnosti pro mu(r)
mu_r=zeros(1,n+m+r);
for i=1:n+m+r
   mu_r(i)=mu*sqrt(i);
end
%%
[h,p_r]=christ_num(r,m,n,lambda_0,lambda_r,mu_r,roots_search,L); % zavola funkci a vypocte cisla h a priblizny vypocet ppsti funkce p_r(t)

%%
% name = 'Piblin vpoet pravdpodobnosti p_r(t)=P(X_t=r)';
% disp(['==========',name,'==========']);
% fprintf('Pocatecni volba m=%1.0f a velikost populace r=%1.0f.\n',m,r)

 %% vykresleni nekolika funkci najednou pro ruzna "m", vaze se s pouzitim for cyklu na
% zacatku dokumentu
% hold on
% subplot(2,2,m)

%% vykresleni nekolika funkci najednou, vaze se s pouzitim for cyklu na
% zacatku dokumentu

if r==0
plot(t,p_r(t),'k-','Linewidth',1.5);
hold on

elseif r==1
    plot(t,p_r(t),'r-','Linewidth',1.5);
   hold on
 
elseif r==2
    plot(t,p_r(t),'k:','Linewidth',1.5);
   hold on
elseif r==3
    plot(t,p_r(t),'b--','Linewidth',1.5);
    hold on
    
elseif r==4
    plot(t,p_r(t),'g-','Linewidth',1.5);
    hold on
elseif r==5
    plot(t,p_r(t),'r:','Linewidth',1.5);
    hold on
    
end

ylim([0 0.4])
xlabel('t','FontSize',15) 
ylabel('odhad p_r(t)','FontSize',15) 
title('$$\lambda_{r}=0.3, \mu_{r}=0.1\sqrt r$$','Interpreter','latex','FontSize', 15)
%title(sprintf('m=%1.0f',m))
end
legend('p_{0,10}(t)','p_{1,10}(t)','p_{2,10}(t)','p_{3,10}(t)','p_{4,10}(t)','p_{5,10}(t)')
hold off
