%%
% priklad 3 - linearni proces zrodu a zaniku
% author: Patrik Drda
clear
close all
clc
%% for cyklus pro vykresleni ruznych variant reseni 
% for m=1:4  %zmena tvaru funkce na zmene hodnoty m
% for r=0:4 %zmena tvaru funkce na zmene hodnoty r
%for LL=1:4 % zmena tvaru funkce na zmene poctu iteraci qd-algoritmu
%% pocatecni hodnoty
r=0;  % velikost populace v case t
m=1; % pocatecni velikost populace v case t=0
n=10; % n-ty aproximant , pri kombinaci r=0, m=0, n=0 dojde k zacykleni
L=110; % pocet iteraci pro QD algoritmus
t=1:20; % volba t
%L=65*LL; % pocet iteraci pro QD algoritmus (pouziti pokud pouzijeme for
%cyklus

%% zadan hodnoty intenzit
mu=0.4;
lambda=0.2;
lambda_0=0.0000000001; % podminka: lambda_0 musi byt vetsi nez 0
 
roots_search=1; % volba metody na vypocet korenu; 1 - pomoci matice a vl. cisel; 2- QD - algoritmus
%% tvorba posloupnosti pro lambda(r)
lambda_r=zeros(1,n+m+r);
for i=1:n+m+r
    lambda_r(i)=lambda*i;
end

%% tvorba posloupnosti pro mu(r)
mu_r=zeros(1,n+m+r);
for i=1:n+m+r
    mu_r(i)=mu*i;
end

%%
[h,p_r]=christ_num(r,m,n,lambda_0,lambda_r,mu_r,roots_search,L); % zavola funkci a vypocte cisla h a priblizny vypocet ppsti funkce p_r(t)
%% presne reseni  pro pocatecni podm. p_1(0)=1, kdyz uvazujme t celociselne
for pp=1:length(t)
AA(pp)=(1-exp((lambda-mu)*pp))/(mu-lambda*exp((lambda-mu)*pp));
if r==0
    p_r_presne(pp)=(mu*AA(pp))^m;
else
p_r_presne(pp)=(1-lambda*AA(pp))*(1-mu*AA(pp))*(lambda*AA(pp))^(r-1);
end
end
%% kdyz uvazujeme t "spojite"
% AA(t)=(1-exp((lambda-mu)*t))/(mu-lambda*exp((lambda-mu)*t));
% if r==0
%     p_r_presne(t)=(mu*AA(t))^m;
% else
% p_r_presne(t)=(1-lambda*AA(t))*(1-mu*AA(t))*(lambda*AA(t))^(r-1);
% end
%%
name = 'Piblin vpoet pravdpodobnosti p_r(t)=P(X_t=r)';
disp(['==========',name,'==========']);
fprintf('Pocatecni volba n=%1.0f, m=%1.0f a velikost populace r=%1.0f.\n',n,m,r)


table=[t' p_r(t)' abs((p_r(t)-p_r_presne(t))')];

fprintf('t\t p_r,n(t)\t      |p_r,n(t)-p_r(t)|\n ')
fprintf('%5.1f\t%5.6f\t%9.20f\n',table')


%vykresleni ppsti funkce a priblizneho reseni v case t
% figure(1)
% plot(t,p_r(t),'k-o',t,p_r_presne(t),'r-')

% vykresleni nekolika funkci najednou, vaze se s pouzitim for cyklu na
% zacatku dokumentu

%  hold on
%  subplot(2,2,m)
% 
% if r==0
% plot(t,p_r(t),'k-','Linewidth',1.5);
% hold on
% 
% elseif r==1
%     plot(t,p_r(t),'r-','Linewidth',1.5);
%    hold on
%  
% elseif r==2
%     plot(t,p_r(t),'k:','Linewidth',1.5);
%    hold on
% elseif r==3
%     plot(t,p_r(t),'b--','Linewidth',1.5);
%     hold on
%     
% elseif r==4
%     plot(t,p_r(t),'g-','Linewidth',1.5);
%     hold on
%     
% end
% 
% ylim([0 1])
% xlim([1 50])
% xlabel('t','FontSize',15) 
% ylabel('odhad p_r(t)','FontSize',15) 
%  title(sprintf('m=%1.0f',m))

%% vykresleni priblizne pravdepodobnostni funkce pro ruzne hodnoty L qd-algoritmu
% hold on
% subplot(2,2,LL)
%plot(r,p_r(t),'k-o')
% xlim([1 length(t)])
% ylim([0 1])
% title(sprintf('L=%1.0f',L))
% xlabel('t') 
% ylabel('odhad p_r(t)') 
% hold off

% end
% legend('p_{0,10}(t)','p_{1,10}(t)','p_{2,10}(t)','p_{3,10}(t)','p_{4,10}(t)')
% hold off
% end
% end