%%
% priklad 1 ... system hromadne obsluhy, varianta (M/M/nekonecno)
%author: Patrik Drda
clear
close all
clc
%% for cyklus pro vykresleni ruznych variant reseni 
%for n=2:5 %  %zmena tvaru funkce na zmene hodnoty n
%for r=0:18 % zmena tvaru funkce na zmene hodnoty r
%for LL=1:4 % zmena tvaru funkce na zmene poctu iteraci qd-algoritmu
%% pocatecni hodnoty
r=5;  % velikost populace v case t
m=0; % pocatecni velikost populace v case t=0
n=10; % n-ty aproximant , pri kombinaci r=0, m=0, n=0 dojde k zacykleni
L=500; % volba iterace qd-algoritmu
%L=20*LL; % pocet iteraci pro QD algoritmus (pouziti pokud pouzijeme for
%cyklus
t=1:20; % volba t
%% zadane hodnoty
mu=0.4;
lambda=0.2;
lambda_0=0.2; % podminka: lambda_0 musi byt vetsi nez 0
 
roots_search=2; % volba metody na vypocet korenu; 1 - pomoci matice a vl. cisel; 2- QD - algoritmus
%% tvorba posloupnosti pro lambda(r)
lambda_r=zeros(1,n+m+r);
for i=1:n+m+r
    lambda_r(i)=lambda;
end

%% tvorba posloupnosti pro mu(r)
mu_r=zeros(1,n+m+r);
for i=1:n+m+r
    mu_r(i)=mu*i;
end
%%
[h,p_r]=christ_num(r,m,n,lambda_0,lambda_r,mu_r,roots_search,L); % zavola funkci a vypocte cisla h a priblizny vypocet ppsti funkce p_r(t)
%% presne reseni pro pocatecni podm. p_0(0)=1, kdyz uvazujme t celociselne
for pp=1:length(t)
p_r_presne(pp)=1/factorial(r)*(lambda/mu)^r*(1-exp(-mu*pp))^r * exp((-lambda/mu)*(1-exp(-mu*pp)));
end
%% kdyz t "spojite"
%p_r_presne(t)=1/factorial(r)*(lambda/mu)^r*(1-exp(-mu*t))^r * exp((-lambda/mu)*(1-exp(-mu*t)));
%
%%
name = 'Piblin vpoet pravdpodobnosti p_r(t)=P(X_t=r)';
disp(['==========',name,'==========']);
fprintf('Pocatecni volba m=%1.0f a velikost populace r=%1.0f.\n',m,r)


table=[t' p_r(t)' abs((p_r(t)-p_r_presne(t))')];

fprintf('t\t p_r,n(t)\t      |p_r,n(t)-p_r(t)|\n ')
fprintf('%5.1f\t%5.6f\t%9.20f\n',table')


%% vykresleni ppsti funkce a priblizneho vypoctu

% figure(1)
% plot(t,p_r(t),'k-o',t,p_r_presne, 'LineWidth',2)
%plot(t,p_r(t),'k-o')

%% vykresledni priblizneho vypoctu pravdepodobnosti v case t pro ruzne volby L qd-algoritmu
% hold on
% subplot(2,2,LL)
%plot(t,p_r(t),'k-o',t,p_r_presne(t),'r-','Linewidth',2)
% title(sprintf('L=%1.0f',L))

%% vykresleni pravdepodobnosti prechodu pro ruzna "m" a "r" v danem case t, napr. t=1
%  hold on
%  subplot(2,2,n-1)
%  plot(r,p_r(1),'k*')
% xlim([1 length(t)])
% %ylim([0 1])
% %title(n)
% xlabel('t') 
% ylabel('odhad p_r(t)') 
%hold off
%end
%end
%end